;-------------------------------------------------------------------------
;   ver.1.0  ATtiny45  .  4
;-------------------------------------------------------------------------
.INCLUDE "tn45def.inc"

	;   
.DEF rg_switch = R11    ;   
.DEF rg_pause = R21     ;  
.DEF rg_ancont = R7     ;  
.DEF rg_chmode = R8     ;    
.DEF rg_exmode = R9     ; 
.DEF rg_stbits = R16    ;    (0  1)
.DEF rg_timark = R17    ;   (0/1)  
.DEF rg_tmsave = R18    ;   RAM  EEPROM
.DEF rg_temp = R24      ;   
.DEF rg_srcopy = R10    ;  SREG   
; XL,XH -  R/W    [ - 1]
; ZL,ZH -   / RAM  EEPROM
; YL,YH -     

	;   
.EQU cn_irbits = 128    ; [Kmax = EEPROM:2]   
.EQU cn_irtime = 125    ; [Tmax = 127] : 64   125 = 8 
.EQU cn_timout = 2      ; (+/-)  : 64   2 = 128 
.EQU cn_prgtm = 6       ; ()   
.EQU cn_prgend = 188    ; : 64  x 188 = 12 c

	;  /
.EQU p_infred = 2       ; PB2 -    
.EQU p_device = 0       ; PB0 -    
.EQU p_progbt = 1       ; PB1 -  .    

	;  /:
.EQU cn_tmask = 0b10000000
;rg_timark = 0bxNNNNNNN -  [N = 0...127] 
;rg_timark = 0b0 -  (0)   
;rg_timark = 0b1 -  (1)   

;------------       -------------

	;   :
.EQU vb_swmode = 0
;rg_switch = 0bxxxxxxx0 -     
;rg_switch = 0bxxxxxxx1 -   

	; .:
.EQU vb_dvmode = 1
;rg_switch = 0bxxxxxx0 -   
;rg_switch = 0bxxxxxx1 -   

	;  :
.EQU vb_irimpl = 7
;rg_switch = 0b0xxxxx -  .0
;rg_switch = 0b1xxxxx -  .1

;------------------- ,    -------------------

	;  1
.MACRO mc_Clear_Timer1
	clr rg_temp                ;  
	out TCNT1, rg_temp
	sbr rg_temp, PSR1          ;  1
	out GTCCR, rg_temp
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;  1
.MACRO mc_Start_Timer1
	mc_Clear_Timer1
	ldi rg_temp, 0b00001001    ; 1 = 256 ( = 15,6 ),
	out TCCR1, rg_temp         ;   = 64 .
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;  1
.MACRO mc_Stop_Timer1
	clr rg_temp
	out TCCR1, rg_temp
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;  0
.MACRO mc_Clear_Timer0
	clr rg_temp                ;  
	out TCNT0, rg_temp
	sbr rg_temp, PSR0          ;  0
	out GTCCR, rg_temp
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;  0
.MACRO mc_Start_Timer0
	mc_Clear_Timer0
	ldi rg_temp, cn_prgend     ; ""
	mov rg_exmode, rg_temp
	ldi rg_temp, 0b00000101    ; 0 = 1024 ( = 3,9 ),
	out TCCR0B, rg_temp        ;   = 256 .
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;  0
.MACRO mc_Stop_Timer0
	clr rg_temp
	out TCCR0B, rg_temp
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;  
.MACRO mc_Test_Counter
	cpi rg_stbits, $00         ;   
	brne Over_Test
	inc rg_stbits
	ret                        ;   
Over_Test:
	cpi rg_stbits, cn_irbits   ;   
	brlo Normal_Run
	ldi XL, cn_irbits - 1      ; [max]   L
	clr XH                     ; [max]   H
	mc_Stop_Timer1
	clr rg_stbits
	rjmp @0                    ;  
Normal_Run:
	mov XL, rg_stbits
	dec XL                     ; [new]   L
	clr XH                     ; [new]   H
	inc rg_stbits
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	; R/W 
.MACRO mc_Load_Address
	ldi ZL, Low(@0)
	ldi ZH, High(@0)
	add ZL, XL                 ;  R/W  L
	adc ZH, XH                 ;  R/W  H
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	; 
.MACRO mc_Compare_Time
	mov rg_temp, rg_timark
	; 
	eor rg_timark, rg_tmsave       ;  
	sbrc rg_timark, vb_irimpl
	rjmp Error_Compare
	; 
	sbr rg_tmsave, cn_tmask        ;  RAM  + [tmask]
	cbr rg_temp, cn_tmask          ;    - [tmask]
	sub rg_tmsave, rg_temp                   ; 
	cpi rg_tmsave, cn_tmask - cn_timout      ; 
	brlo Error_Compare
	cpi rg_tmsave, cn_tmask + cn_timout + 1  ; 
	brsh Error_Compare
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;  
; : 4   252 = 1 c
.MACRO mc_Time_Contact
	ldi rg_temp, 252
	mov rg_ancont, rg_temp
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	; : [N] x 50 
.MACRO mc_Set_Pause
	ldi rg_pause, @0
	wdr
Return:
	rcall Time_50ms
	dec rg_pause
	brne Return
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;    [50  N] 
.MACRO mc_Light_LED
	cbi PORTB, p_progbt
	sbi DDRB, p_progbt
	mc_Set_Pause @0
	sbi PORTB, p_progbt
	cbi DDRB, p_progbt
	nop nop nop
.ENDM
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	;    [50  N] 
.MACRO mc_Black_LED
	sbi PORTB, p_progbt
	sbi DDRB, p_progbt
	mc_Set_Pause @0
	cbi DDRB, p_progbt
	nop nop nop
.ENDM

;=========================================================================

	; 
.CSEG
.ORG $000
	rjmp Reset
.ORG $003
	rjmp Timer1_CompA
.ORG $00A
	rjmp Timer0_CompA

;----------------------   ---------------------------

	;  
Reset:
	clr R0 clr R1 clr R2 clr R3 clr R4 clr R5 clr R6 clr R7 clr R8
	clr R9 clr R10 clr R11 clr R12 clr R13 clr R14 clr R15 clr R16
	clr R17 clr R18 clr R19 clr R20 clr R21 clr R22 clr R23 clr R24
	clr R25 clr R26 clr R27 clr R28 clr R29 clr R30 clr R31

	;  
	ldi rg_temp, Low(RAMEND)
	out SPL, rg_temp
	ldi rg_temp, High(RAMEND)
	out SPH, rg_temp

	; 
	sbi DDRB, p_device         ;   -   PB0
	sbi PORTB, p_progbt        ;    .

	; 
	rcall Load_CodeIR          ;    EEPROM
	mc_Time_Contact            ;  
	set ; .1
	bld rg_switch, vb_irimpl   ;   

	;  T1
	ldi rg_temp, cn_irtime     ; :  = 0...127 ( )
	out OCR1A, rg_temp

	;  T0
	ldi rg_temp, 0b00000010    ;  -     OCR0A
	out TCCR0A, rg_temp
	ldi rg_temp, 250           ; : 256  x 250 = 64 
	out OCR0A, rg_temp

	;  
	ldi rg_temp, 0b00001011    ;  125   U.= 5,0 
	wdr                        ;  
	out WDTCR, rg_temp         ; 

	; 
	ldi rg_temp, 0b01010000    ;  1    OCR1A
	out TIMSK, rg_temp         ;  0    OCR0A
	sei

;=========================================================================

	; 
Program:
	wdr                            ;  
	sbrc rg_switch, vb_swmode      ; YES/NO
	rjmp PortIR_Test1
	; .
	sbis PINB, p_progbt
	rjmp Contact_Start
	; 
	mc_Time_Contact
	rjmp PortIR_Test1
	; 
Contact_Start:
	dec rg_ancont
	brne PortIR_Test1
	rcall Button_Press

	;    .1
PortIR_Test1:
	sbis PINB, p_infred
	rjmp PortIR_Test0
	sbrc rg_switch, vb_irimpl      ;   
	rjmp Program
	; 
	mc_Stop_Timer1
	in rg_timark, TCNT1
	mc_Start_Timer1
	set ; .1
	bld rg_timark, vb_irimpl
	bld rg_switch, vb_irimpl
	;  
	rcall Reading_CodeIR
	rcall Program_CodeIR
	rjmp Program

	;    .0
PortIR_Test0:
	sbrs rg_switch, vb_irimpl      ;   
	rjmp Program
	; 
	mc_Stop_Timer1
	in rg_timark, TCNT1
	mc_Start_Timer1
	clt ; .0
	bld rg_timark, vb_irimpl
	bld rg_switch, vb_irimpl
	;  
	rcall Reading_CodeIR
	rcall Program_CodeIR
	rjmp Program

;-------------------------------------------------------------------------

	;  
Button_Press:
	mc_Stop_Timer1
	ldi rg_temp, cn_prgtm         ;   .
	mov rg_chmode, rg_temp
	; 
Button_Scan:
	mc_Light_LED 10
	mc_Black_LED 10
	sbic PINB, p_progbt
	rjmp Device_Signal
	dec rg_chmode
	brne Button_Scan
	; :
	set ;""
	bld rg_switch, vb_swmode
	mc_Start_Timer0               ; ""
	;  
	cbi PORTB, p_progbt
	sbi DDRB, p_progbt
	clr rg_stbits
	ret

	; 
Device_Signal:
	rcall Switch_Device
	rcall Load_CodeIR             ;    EEPROM
	mc_Time_Contact               ; 
	clr rg_stbits
	ret

;-------------------------------------------------------------------------

	;  
Switch_Device:
	sbrc rg_switch, vb_dvmode        ;  
	rjmp Device_OFF
	set ; 
	bld rg_switch, vb_dvmode
	sbi PORTB, p_device
	ret
Device_OFF:
	clt ; 
	bld rg_switch, vb_dvmode
	cbi PORTB, p_device
	ret

;-------------------------------------------------------------------------

	;  -     
Reading_CodeIR:
	sbrc rg_switch, vb_swmode           ;  YES/NO
	ret
	mc_Test_Counter Reading_Actions
	;  RAM  
	mc_Load_Address RAM_CodeIR
	ld rg_tmsave, Z
	; 
	mc_Compare_Time
	ret
Error_Compare:
	ldi rg_stbits, $01
	ret

	;  
Reading_Actions:
	mc_Load_Address RAM_CodeIR
	ld rg_tmsave, Z
	mc_Compare_Time
	; .
	mc_Light_LED 2
	mc_Black_LED 2
	mc_Light_LED 2
	mc_Black_LED 2
	mc_Light_LED 2
	mc_Black_LED 6
	; 
	rcall Switch_Device
	rcall Load_CodeIR               ;    EEPROM
	mc_Time_Contact                 ; 
	mc_Set_Pause 8
	ret

;-------------------------------------------------------------------------

	;  -   
Program_CodeIR:
	sbrs rg_switch, vb_swmode           ;  YES/NO
	ret
	mc_Stop_Timer0                      ;  
	mc_Test_Counter Program_Actions
	;  RAM   
	mc_Load_Address RAM_CodeIR
	st Z, rg_timark
	;  ""
	nop nop nop nop nop nop nop
	nop nop nop nop nop nop nop
	ret

	;  
Program_Actions:
	mc_Load_Address RAM_CodeIR
	st Z, rg_timark
	; .
	mc_Black_LED 2
	mc_Light_LED 2
	mc_Black_LED 2
	mc_Light_LED 2
	mc_Black_LED 2
	mc_Light_LED 2
	mc_Black_LED 6
	;   EEPROM
	rcall Save_CodeIR
	clt ;  ""
	bld rg_switch, vb_swmode
	mc_Time_Contact                     ; 
	mc_Set_Pause 8
	ret

;-------------------------------------------------------------------------

	;    RAM  EEPROM
Save_CodeIR:
	ldi rg_stbits, $01
Save_Start:
	mc_Test_Counter Save_Finish
	;    RAM
	mc_Load_Address RAM_CodeIR
	ld rg_tmsave, Z
	;   EEPROM
	rcall EEPROM_Write
	rjmp Save_Start

Save_Finish:
	mc_Load_Address RAM_CodeIR
	ld rg_tmsave, Z
	rcall EEPROM_Write
	ret

;-------------------------------------------------------------------------

	;    EEPROM  RAM
Load_CodeIR:
	ldi rg_stbits, $01
Load_Start:
	mc_Test_Counter Load_Finish
	rcall EEPROM_Read
	;    RAM
	mc_Load_Address RAM_CodeIR
	st Z, rg_tmsave
	rjmp Load_Start

Load_Finish:
	rcall EEPROM_Read
	mc_Load_Address RAM_CodeIR
	st Z, rg_tmsave
	ret

;-------------------------------------------------------------------------

	;    EEPROM
EEPROM_Read:
	sbic EECR, EEPE           ;   
	rjmp EEPROM_Read
	rcall Select_Address
	out EEARH, ZH             ;   
	out EEARL, ZL             ;   
	sbi EECR, EERE            ;  EEPROM
	nop ;
	in rg_tmsave, EEDR        ;  
	wdr                       ;  
	ret

;-------------------------------------------------------------------------

	;    EEPROM
EEPROM_Write:
	sbic EECR, EEPE           ;   
	rjmp EEPROM_Write
	rcall Select_Address
	out EEARH, ZH             ;   
	out EEARL, ZL             ;   
	out EEDR, rg_tmsave       ;   
	sbi EECR, EEMPE           ;  EEPROM
	sbi EECR, EEPE            ;   EEPROM
	sbi EECR, EEPE            ;  2 
	sbi EECR, EEPE            ;  3 
	sbi EECR, EEPE            ;  4 
	wdr                       ;  
	ret

;-------------------------------------------------------------------------

	;   R/W   EEPROM
Select_Address:
	sbrs rg_switch, vb_dvmode       ;  .
	rjmp Second_Address
	mc_Load_Address EPR_CodeONDV
	ret
Second_Address:
	mc_Load_Address EPR_CodeOFFD
	ret

;-------------------------------------------------------------------------

	;  
Time_50ms:
	ldi YH, 255
TH:	ldi YL, 255
TL:	dec YL
	brne TL
	dec YH
	brne TH
	wdr
	ret

;---------------     1  0 ----------------

	;   
Timer1_CompA:
	in rg_srcopy, SREG
	mc_Clear_Timer1                 ; 
	ldi rg_timark, cn_irtime        ;  
	;  
	sbr rg_timark, cn_tmask
	sbis PINB, p_infred
	cbr rg_timark, cn_tmask
	;  
	rcall Reading_CodeIR
	rcall Program_CodeIR
	out SREG, rg_srcopy
	reti
;_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

	; 
Timer0_CompA:
	in rg_srcopy, SREG
	dec rg_exmode                   ; 
	breq Exit_ModePRG
	out SREG, rg_srcopy
	reti
Exit_ModePRG:
	mc_Stop_Timer0
	clt ;  ""
	bld rg_switch, vb_swmode
	mc_Black_LED 2
	mc_Time_Contact                 ; 
	out SREG, rg_srcopy
	reti

;=========================================================================

	;     
.DSEG
	RAM_CodeIR: .BYTE cn_irbits

;-------------------------------------------------------------------------

	;   EEPROM  
.ESEG
	EPR_CodeONDV: .BYTE cn_irbits
	EPR_CodeOFFD: .BYTE cn_irbits

;=========================================================================

